lexer grammar JSON;
options {
  language=Java;

}

@header {
//--------------------------------------
// XerialJ Project
//
// JSONLexer.java
// Since: Apr 26, 2007
//
//--------------------------------------
package org.xerial.json.impl;
}

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 71
Colon: ':';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 72
Comma: ',';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 73
LBrace: '{';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 74
RBrace: '}';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 75
LBracket: '[';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 76
RBracket: ']';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 77
fragment Dot: '.';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 78
TRUE:  'true';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 79
FALSE: 'false';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 80
NULL: 'null';

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 82
fragment Digit: '0' .. '9';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 83
fragment HexDigit: ('0' .. '9' | 'A' .. 'F' | 'a' .. 'f');
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 84
fragment UnicodeChar: ~('"'| '\\');
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 85
fragment StringChar :  UnicodeChar | EscapeSequence;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 87
fragment EscapeSequence
	: '\\' ('\"' | '\\' | '/' | 'b' | 'f' | 'n' | 'r' | 't' | 'u' HexDigit HexDigit HexDigit HexDigit)
	;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 91
fragment Int: '-'? ('0' | '1'..'9' Digit*);
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 92
fragment Frac: Dot Digit+;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 93
fragment Exp: ('e' | 'E') ('+' | '-')? Digit+;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 95
WhiteSpace: (' ' | '\r' | '\t' | '\u000C' | '\n') { $channel=HIDDEN; };

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 97
String: '"' StringChar* '"';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 98
Integer: Int;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\json\impl\JSON.g" 99
Double:  Int (Frac Exp? | Exp);

// parser rules
