lexer grammar InLineJSON;
options {
  language=Java;

}

@members {
  public int nesting = 1;	// json fragment begins with nesting
}
@header {
//--------------------------------------
// XerialJ Project
//
// InLineJSONLexer.java
// Since: Apr 26, 2007
//
//--------------------------------------
package org.xerial.silk.impl;
}

T__23 : 'true' ;
T__24 : 'false' ;
T__25 : 'null' ;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 61
WhiteSpace: (' ' | '\r' | '\t' | '\u000C' | '\n') { $channel=HIDDEN; };

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 63
fragment Digit: '0' .. '9';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 64
fragment Letter: 'A' .. 'F' | 'a' .. 'f';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 65
fragment HexDigit: Digit | Letter;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 66
fragment UnicodeChar: ~('"'| '\\');
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 67
fragment EscapeSequence
	: '\\' ('\"' | '\\' | '/' | 'b' | 'f' | 'n' | 'r' | 't' | 'u' HexDigit HexDigit HexDigit HexDigit)
	; 

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 71
fragment StringChar :  UnicodeChar | EscapeSequence;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 73
fragment StringChar_s: StringChar*;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 74
String: '"' s=StringChar_s '"' { setText($s.text); };


// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 77
Colon: ':';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 78
Comma: ',';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 79
Integer: '-'? ('0' | '1'..'9' Digit*);
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 80
fragment Frac: '.' Digit+;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 81
fragment Exp: ('e' | 'E') ('+' | '-')? Digit+;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 82
Double: Integer (Frac Exp? | Exp);

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 84
LBrace: '{' { nesting++; } ;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 85
RBrace: '}' { nesting--; if (nesting<=0) { emit(Token.EOF_TOKEN); } };
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 86
LBracket: '[' { nesting++; } ;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\silk\impl\InLineJSON.g" 87
RBracket: ']' { nesting--; if (nesting<=0) { emit(Token.EOF_TOKEN); } };

/*
fragment NameChar: Letter | Digit | '_' | '-' | '@' | '.';
QName: (Letter | '_') NameChar*;
*/

// parser

